UNIT TJUTIL;
interface
  function left(s:string; p:integer):string;
  function right(s:string; p:integer):string;
  function mid(s:string; p, l:integer):string;
  function trim(s:string):string;
  function ltrim(s:string):string;
  function rtrim(s:string):string;
  function alltrim(s:string):string;
  function searchini(fn, sn, ss:string):string;  {filename, sectionname, searchstring}
  procedure writeini(fn, sn, ss, nv:string);  {filename, sectionname, searchstring, new_value}
  function upper(s:string):string;
  function padr(s:string; l:integer; c:char):string;
  function padl(s:string; l:integer; c:char):string;
  function pad(s:string; l:integer; c:char):string;
  function hex(num:byte):string;
  function bin(num:byte):string;

implementation
  uses
    dos;
  function left(s:string; p:integer):string;
  begin
    if p > 0 then
      delete(s, p+1, length(s)-p)
    else
      s:='';
    left:=s;
  end;

  function right(s:string; p:integer):string;
  begin
    if p > 0 then
      delete(s, 1, length(s)-p)
    else
      s:='';
    right:=s;
  end;

  function mid(s:string; p, l:integer):string;
  begin
    if (p > 0) and (l > 0) then
    begin
      s:=right(s, length(s)-p+1);
      mid:=left(s, l);
    end else
      s:='';
  end;

  function trim(s:string):string;
  var
    i:integer;
  begin
    i:=length(s);
    while (s[i] = ' ') and (i >= 1) do
    begin
      i:=i-1;
    end;
    if i > 0 then
      trim:=left(s, i)
    else
      trim:='';
  end;

  function ltrim(s:string):string;
  var
    i:integer;
  begin
    i:=1;
    while (s[i] = ' ') and (i <= length(s)) do
    begin
      i:=i+1;
    end;
    if i > length(s) then
      ltrim:=''
    else
      ltrim:=right(s, length(s)-i+1);
  end;

  function rtrim(s:string):string;
  begin
    rtrim:=trim(s);
  end;

  function alltrim(s:string):string;
  begin
    s:=ltrim(s);
    alltrim:=rtrim(s);
  end;

  function searchini(fn, sn, ss:string):string;
  var
    FromF: text;
    temp:string;
    founds:boolean;
    found:boolean;
  begin
    searchini:='';
    founds:=false;  {found section}
    found:=false;   {found search string}
    Assign(FromF, fn);
    {$I-}
    Reset(FromF);
    {$I+}
    if IOResult = 0 then
    begin
      repeat
        readln(FromF, temp);
        if left(temp,1) <> ';' then
        begin
          if left(temp,1) <> '[' then
          begin
            if founds = true then
            begin
              if upper(alltrim(left(temp, pos('=', temp)-1))) = upper(ss) then
              begin
                searchini:=alltrim(right(temp, length(temp)-pos('=', temp)));
                found:=true;
              end;
            end;
          end else
            if upper(temp) = upper(sn) then
              founds:=true
            else
              founds:=false;
        end;
      until found or eof(FromF);
      Close(FromF);
    end;
  end;

  procedure writeini(fn, sn, ss, nv:string);
  var
    FromF, ToF: text;
    temp:string;
    founds:boolean;
    found:boolean;
    fdir:dirstr;
    fname:namestr;
    fext:extstr;
  begin
    founds:=false;  {found section}
    found:=false;   {found search string}
    fsplit(fn, fdir, fname, fext);
    if Fsearch(fn, fdir) = '' then
    begin
      Assign(FromF, fn);
      Rewrite(FromF);
      writeln(FromF, sn);
      writeln(FromF, ss+'='+nv);
      Close(FromF);
    end else
    begin
      Assign(FromF, fdir+fname+'.IN$');
      Rewrite(FromF);
      Close(FromF);
      Erase(FromF);
      Assign(FromF, fn);
      rename(FromF, fdir+fname+'.IN$');
      Reset(FromF);
      Assign(ToF, fn);
      Rewrite(ToF);
      repeat
        readln(FromF, temp);
        if left(temp,1) <> ';' then
        begin
          if left(temp,1) <> '[' then
          begin
            if founds = true then
            begin
              if upper(alltrim(left(temp, pos('=', temp)-1))) = upper(ss) then
              begin
                writeln(ToF, ss+'='+nv);
                found:=true;
              end else
              begin
                writeln(ToF, temp);
              end;
            end else
            begin
              writeln(ToF, temp);
            end;
          end else
          begin
            if (founds = true) and (found = false) then
            begin
              writeln(ToF, ss+'='+nv);
              found:=true;
            end;
            writeln(ToF, temp);
            if upper(temp) = upper(sn) then
            begin
              founds:=true;
            end else
            begin
              founds:=false;
            end;
          end;
        end else
        begin
          writeln(ToF, temp);
        end;
      until eof(FromF);
      if found = false then
      begin
        if founds = true then
        begin
          writeln(ToF, ss+'='+nv);
        end else
        begin
          writeln(ToF, sn);
          writeln(ToF, ss+'='+nv);
        end;
      end;
      Close(FromF);
      Erase(FromF);
      Close(ToF);
    end;
  end;

  function upper(s:string):string;
  var
    i:Integer;
  begin
    for i := 1 to Length(s) do
      s[i] := UpCase(s[i]);
    upper:=s;
  end;

  function padr(s:string; l:integer; c:char):string;
  begin
    while length(s) < l do
    begin
      s:=s+c;
    end;
    padr:=s;
  end;

  function padl(s:string; l:integer; c:char):string;
  begin
    while l > length(s) do
    begin
      s:=c+s;
    end;
    padl:=s;
  end;

  function pad(s:string; l:integer; c:char):string;
  begin
    pad:=padr(s, l, c)
  end;

  function hex(num:byte):string;
  var
    hexstring:array[0..15] of char;
    function _hex(num:byte):string;
    begin
      if num < 16 then
      begin
        _hex:=hexstring[num];
      end else
      begin
        _hex:=_hex(num div 16)+hexstring[(num mod 16)];
      end;
    end;
  begin
    hexstring:='0123456789ABCDEF';
    hex:=pad(_hex(num),2,'0');
  end;

  function bin(num:byte):string;
  var
    binstring:array[0..1] of char;
    function _bin(num:byte):string;
    begin
      if num <= 1 then
      begin
        _bin:=binstring[num];
      end else
      begin
        _bin:=_bin(num div 2)+binstring[(num mod 2)];
      end;
    end;
  begin
    binstring:='01';
    bin:=pad(_bin(num),8,'0');
  end;
end.
