{ WINPASS.EXE - Version 1.0 }
{ Writen by Tim Jones       }

{ This program will encrypt/decrypt Windows 3.x screen saver passwords }
Program myWINPASS;
uses
  tjutil;
const
  version='1.0';
var
  fcount:integer;
  pwcount:integer;
  encryptflag:boolean;
  i:integer;
  param:string;
  s1name:string;
  pw1:string;

function exor(x1, x2:byte):byte;
begin
  case x1 xor x2 of
    $21..$3C, $3E..$5A, $5C, $5E..$7E, $91..$92, $A0..$FF: x2:=x1 xor x2;
  end;
  exor:=x2;
end;

function encrypt(pw:string):string;
var
  encryptpw:string;
  pwlength:integer;
  pos:integer;
  hold:byte;
begin
  pwlength:=length(pw);
  encryptpw:='';
  if pwlength > 0 then
  begin
    encryptpw:=upper(pw);
    for pos:=1 to pwlength do
    begin
      hold:=ord(encryptpw[pos]);
      hold:=exor(pwlength, hold);
      if pos = 1 then
      begin
        hold:=exor($2A, hold);
      end else
      begin
        hold:=exor(pos-1, hold);
        hold:=exor(ord(encryptpw[pos-1]), hold);
      end;
      encryptpw[pos]:=chr(hold);
    end;
    if pwlength > 1 then
    begin
      for pos:=pwlength downto 1 do
      begin
        hold:=ord(encryptpw[pos]);
        hold:=exor(pwlength, hold);
        if pos = pwlength then
        begin
          hold:=exor($2A, hold);
        end else
        begin
          hold:=exor(pos-1, hold);
          hold:=exor(ord(encryptpw[pos+1]), hold);
        end;
        encryptpw[pos]:=chr(hold);
      end;
    end;
  end;
  encrypt:=encryptpw;
end;

function decrypt(epw:string):string;
var
  decryptpw:string;
  pwlength:integer;
  pos:integer;
  hold:byte;
begin
  pwlength:=length(epw);
  decryptpw:='';
  decryptpw:=epw;
  if pwlength > 0 then
  begin
    if pwlength > 1 then
    begin
      for pos:=1 to pwlength do
      begin
        hold:=ord(decryptpw[pos]);
        if pos < pwlength then
        begin
          hold:=exor(ord(decryptpw[pos+1]), hold);
          hold:=exor(pos-1, hold);
        end;
        if pos = pwlength then
        begin
          hold:=exor($2A, hold);
        end;
        hold:=exor(pwlength, hold);
        decryptpw[pos]:=chr(hold);
      end;
    end;
    for pos:=pwlength downto 1 do
    begin
      hold:=ord(decryptpw[pos]);
      if pos = 1 then
      begin
        hold:=exor($2A, hold);
      end else
      begin
        hold:=exor(ord(decryptpw[pos-1]), hold);
        hold:=exor(pos-1, hold);
      end;
      hold:=exor(pwlength, hold);
      decryptpw[pos]:=chr(hold);
    end;
  end;
  decryptpw:=upper(decryptpw);
  decrypt:=decryptpw;
end;

procedure syntax(errmsg:string);
begin
  writeln('This program will encrypt/decrypt Windows 3.x screensaver passwords.');
  writeln('The encrypted password may be either typed in or the program can');
  writeln('search for it in a given file.');
  writeln;
  writeln('Usage: WINPASS [options] [password]');
  writeln;
  writeln('  Options:');
  writeln('    -f:file = Search file for PASSWORD=xxxx under section [ScreenSaver].');
  writeln('    -f      = Same as above but defaults to CONTROL.INI');
  writeln('    -e      = Perform encryption rather than decryption of the password');
  writeln('    -?      = Display this help text');
  writeln;
  writeln('  Examples:');
  writeln('    WINPASS -f => decodes PASSWORD=xxxx in CONTROL.INI');
  writeln('    WINPASS -f:c:\test.ini  => decodes PASSWORD=xxxx in TEST.INI');
  writeln('    WINPASS *HjgF => hello');
  writeln('    WINPASS -e hello => *HjgF');
  writeln('    WINPASS -e "-=hello=-" => use quotes if leading char is / or -');
  writeln('    WINPASS -e ''/\hello/\'' => single quotes are also acceptiable');
  writeln('    WINPASS -f:c:\test.ini hello => Invalid (too many password sources)');
  writeln('    WINPASS -e "hi there" => Invalid (spaces in password are not allowed)');
  if errmsg <> '' then
  begin
    writeln('Error:');
    writeln(errmsg);
    writeln;
    halt(1);
  end;
  halt(0);
end;

procedure munge;
var
  pw:string;
  fn:file;
begin
  pw:=pw1;
  if s1name <> '' then
  begin
    assign(fn, s1name);
    {$I-}
    reset(fn);
    {$I+}
    if ioresult <> 0 then syntax('Could not open file: '+s1name);
    pw:=searchini(s1name, '[ScreenSaver]', 'password');
    writeln('Searching file: ',s1name);
  end;
  if encryptflag = true then
  begin
    writeln('[',pw,'] = [',encrypt(pw),']');
  end else
  begin
    writeln('[',pw,'] = [',decrypt(pw),']');
  end;
end;

begin
  writeln('WINPASS.EXE v',version,' - written by Tim Jones');
  writeln;
  fcount:=0;
  encryptflag:=false;
  pwcount:=0;
  for i:=1 to paramcount do
  begin
    param:=upper(paramstr(i));
    if (left(param,1) = '/') or (left(param,1) = '-') then
    begin
      case param[2] of
        '?':syntax('');
        'F':begin
              {must be a filename}
              if length(param) > 2 then
              begin
                if param[3] <> ':' then syntax('Unknown parameter:'+param);
              end;
              fcount:=fcount+1;
              case fcount of
                1: if length(param) = 2 then
                     s1name:='control.ini'
                   else
                     s1name:=right(param, length(param)-3);
              else
                syntax('Too many file parameters:'+param);
              end; {case}
            end;
        'E': encryptflag:=true;
      end;
    end else
    begin
      {must be a password}
      param:=paramstr(i);  {restore upper/lower case}
      if   (left(param,1) = '"') and (right(param,1) = '"')
        or (left(param,1) = ''') and (right(param,1) = ''') then
      begin
        param:=mid(param, 2, length(param)-2);
      end;
      pwcount:=pwcount+1;
      case pwcount of
        1: pw1:=param;
      else
        syntax('Too many password parameters:'+param);
      end;
    end;
  end;
  if (fcount = 0) and (pwcount = 0) then syntax('');
  if (fcount = 1) and (pwcount = 1) then syntax('Too many password sources');
  munge;
end.

